//
//  ViewController.m
//  HttpsCertificationDemo
//
//  @author wlf(Andy)
//  @datetime 2016-02-24 16:21 GMT+8
//  @email 411086563@qq.com
//

#import "ViewController.h"
#import "AFNetworking.h"
#import "HttpsUtil.h"

#define SERVER_URL @"www.andy5.me"
#define HTTPS_SERVER_URL @"https://www.andy5.me"

@interface ViewController ()

@property (weak, nonatomic) IBOutlet UITextView *tvResult;
@property (weak, nonatomic) IBOutlet UIWebView *wvResult;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)testHttps:(UIButton *)sender {
    
    AFHTTPSessionManager *manager =[AFHTTPSessionManager manager];
    
    NSArray *serverCersNames = [[NSArray alloc] initWithObjects:@"server.cer", nil];
    [HttpsUtil configHTTPSessionManager:manager serverCers:serverCersNames clientP12:@"client_cert_lib.p12" clientP12Password:@"c123456" isSelfCa:true];// 使用自签名CA给服务器server证书签名的isSelfCa为true，第三方权威CA签名的isSelfCa为false，当设置isSelfCa为false时，需要注释掉Info.plist中整个NSAppTransportSecurity节点的配置
    manager.responseSerializer = [AFHTTPResponseSerializer serializer];
    manager.requestSerializer.timeoutInterval = 30.0f;
    
    [_tvResult setText:[NSString stringWithFormat:@"正在从%@获取数据....",HTTPS_SERVER_URL]];
    [_wvResult loadHTMLString:@"" baseURL:nil];
    
    [manager GET:HTTPS_SERVER_URL parameters:nil progress:^(NSProgress * _Nonnull downloadProgress) {
        //
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        NSString *result = [[NSString alloc]initWithData:responseObject encoding:NSUTF8StringEncoding];
        NSLog(@"获取数据成功\n%@",result);
        [_tvResult setText:[NSString stringWithFormat:@"从%@获取数据成功！",HTTPS_SERVER_URL]];
        [_wvResult loadHTMLString:result baseURL:nil];
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        NSLog(@"获取数据失败\n%@",error);
        [_tvResult setText:[NSString stringWithFormat:@"从%@获取数据失败！\n%@",HTTPS_SERVER_URL,error]];
    }];
}


@end
